--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/modulebuilder/index.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/modulebuilder/index.php	2025-06-27 11:43:57.413887000 +0000
@@ -600,7 +600,6 @@
 	// Now we update the object file to set $this->isextrafieldmanaged to 1
 	$srcfile = $dirins.'/'.strtolower($module).'/class/'.strtolower($objectname).'.class.php';
 	$arrayreplacement = array('/\$this->isextrafieldmanaged = 0;/' => '$this->isextrafieldmanaged = 1;');
-	$arrayreplacement = array('/\$isextrafieldmanaged = 0;/' => '$isextrafieldmanaged = 1;');
 	dolReplaceInFile($srcfile, $arrayreplacement, '', '0', 0, 1);
 }
 
@@ -1225,10 +1224,10 @@
 				if ($fieldname == 'fk_soc') {
 					$label = 'ThirdParty';
 				}
-				if (in_array($fieldname, array('tms', 'date_modification'))) {
+				if ($fieldname == 'tms') {
 					$label = 'DateModification';
 				}
-				if (in_array($fieldname, array('datec', 'date_creation'))) {
+				if ($fieldname == 'datec') {
 					$label = 'DateCreation';
 				}
 				if ($fieldname == 'date_valid') {
@@ -1321,31 +1320,16 @@
 				}
 
 				// type
-				$picto = '';
-				if (isset($obj->Picto)) {	// This should never exists
+				if (isset($obj->Picto)) {
 					$picto = $obj->Picto;
 				}
-				if (preg_match('/^fk_soc/', $obj->Field)) {
+				if ($obj->Field == 'fk_soc') {
 					$picto = 'company';
-				} elseif (preg_match('/^fk_contact/', $obj->Field)) {
-					$picto = 'contact';
-				} elseif (preg_match('/^fk_bank/', $obj->Field)) {
-					$picto = 'bank';
-				} elseif (preg_match('/^fk_user/', $obj->Field)) {
-					$picto = 'user';
-				} elseif (preg_match('/^fk_warehouse/', $obj->Field)) {
-					$picto = 'warehouse';
-				} elseif (preg_match('/^fk_prod/', $obj->Field)) {
-					$picto = 'product';
-				} elseif (preg_match('/^fk_proj/', $obj->Field)) {
+				}
+				if (preg_match('/^fk_proj/', $obj->Field)) {
 					$picto = 'project';
-				} elseif (preg_match('/^fk_task/', $obj->Field)) {
-					$picto = 'task';
 				}
 
-				// lang
-				$lang = $module.'@'.$module;
-
 				// Build the property string
 				$stringforproperties .= "'".$obj->Field."' => array('type' => '".$type."', 'label' => '".$label."',";
 				if ($default != '') {
@@ -1378,9 +1362,6 @@
 				if ($csslist) {
 					$stringforproperties .= ", 'csslist' => '".$csslist."'";
 				}
-
-				$stringforproperties .= ", 'lang' => '".$lang."'";
-
 				$stringforproperties .= "),\n";
 				$i += 5;
 			}
@@ -3491,11 +3472,7 @@
 	print '<input type="text" name="editorurl" value="'.(GETPOSTISSET('editorurl') ? GETPOST('editorurl') : getDolGlobalString('MODULEBUILDER_SPECIFIC_EDITOR_URL', $mysoc->url)).'" placeholder="'.dol_escape_htmltag($langs->trans("EditorUrl")).'"><br>';
 	print '</div></div>';
 
-	print '</div>';	// End div tagtable
-
-	print '<br><center>';
-	print '<input type="submit" class="button" name="create" value="'.dol_escape_htmltag($langs->trans("Create")).'"'.($dirins ? '' : ' disabled="disabled"').'>';
-	print '</center>';
+	print '<br><input type="submit" class="button" name="create" value="'.dol_escape_htmltag($langs->trans("Create")).'"'.($dirins ? '' : ' disabled="disabled"').'>';
 	print '</form>';
 } elseif ($module == 'deletemodule') {
 	print '<!-- Form to init a module -->'."\n";

########## modulebuilder/template/class/actions_mymodule.class.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/mrp/class/api_mos.class.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/mrp/class/api_mos.class.php	2025-06-27 11:43:57.682041000 +0000
@@ -108,7 +108,7 @@
 		$obj_ret = array();
 		$tmpobject = new Mo($this->db);
 
-		$socid = DolibarrApiAccess::$user->socid ?: 0;
+		$socid = DolibarrApiAccess::$user->socid ? DolibarrApiAccess::$user->socid : 0;
 
 		$restrictonsocid = 0; // Set to 1 if there is a field socid in table of object
 

########## mrp/class/mo.class.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/mrp/class/mo.class.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/mrp/class/mo.class.php	2025-06-27 11:43:57.684180000 +0000
@@ -2045,10 +2045,7 @@
 		if ($this->status != Mo::STATUS_VALIDATED && $this->status != Mo::STATUS_INPROGRESS) {
 			return false;
 		}
-		if (empty($this->date_end_planned)) {
-			return false;
-		}
-		return (dol_now() > ((int) $this->date_end_planned + $conf->mrp->progress->warning_delay));
+		return (dol_now() > ($this->date_end_planned + $conf->mrp->progress->warning_delay));
 	}
 
 

########## mrp/mo_list.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/mrp/mo_list.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/mrp/mo_list.php	2025-06-27 11:43:57.693323000 +0000
@@ -32,6 +32,7 @@
 require_once DOL_DOCUMENT_ROOT.'/core/lib/company.lib.php';
 require_once DOL_DOCUMENT_ROOT.'/bom/class/bom.class.php';
 require_once DOL_DOCUMENT_ROOT.'/product/class/product.class.php';
+
 // load mrp libraries
 require_once __DIR__.'/class/mo.class.php';
 
@@ -57,7 +58,6 @@
 $backtopage = GETPOST('backtopage', 'alpha'); // Go back to a dedicated page
 $optioncss  = GETPOST('optioncss', 'aZ'); // Option for the css output (always '' except when 'print')
 $mode = GETPOST('mode', 'alpha');
-$groupby = GETPOST('groupby', 'aZ09');	// Example: $groupby = 'p.fk_opp_status' or $groupby = 'p.fk_statut'
 
 $id = GETPOSTINT('id');
 
@@ -65,7 +65,7 @@
 $limit = GETPOSTINT('limit') ? GETPOSTINT('limit') : $conf->liste_limit;
 $sortfield = GETPOST('sortfield', 'aZ09comma');
 $sortorder = GETPOST('sortorder', 'aZ09comma');
-$page = GETPOSTISSET('pageplusone') ? (GETPOSTINT('pageplusone') - 1) : GETPOSTINT('page');
+$page = GETPOSTISSET('pageplusone') ? (GETPOSTINT('pageplusone') - 1) : GETPOSTINT("page");
 $also_cancel_consumed_and_produced_lines = (GETPOST('alsoCancelConsumedAndProducedLines', 'alpha') ? 1 : 0);
 $changeDate = GETPOST('change_date', 'alpha');
 
@@ -128,16 +128,15 @@
 }
 
 // Definition of array of fields for columns
-$tableprefix = 't';
 $arrayfields = array();
 foreach ($object->fields as $key => $val) {
 	// If $val['visible']==0, then we never show the field
 	if (!empty($val['visible'])) {
 		$visible = (int) dol_eval((string) $val['visible'], 1);
-		$arrayfields[$tableprefix.'.'.$key] = array(
+		$arrayfields['t.'.$key] = array(
 			'label' => $val['label'],
-			'checked' => (($visible < 0) ? '0' : '1'),
-			'enabled' => (string) (int) (abs($visible) != 3 && (bool) dol_eval((string) $val['enabled'], 1)),
+			'checked' => (($visible < 0) ? 0 : 1),
+			'enabled' => (abs($visible) != 3 && (bool) dol_eval($val['enabled'], 1)),
 			'position' => $val['position'],
 			'help' => isset($val['help']) ? $val['help'] : ''
 		);
@@ -145,7 +144,7 @@
 
 	if ($key == 'fk_parent_line') {
 		$visible = (int) dol_eval((string) $val['visible'], 1);
-		$arrayfields[$tableprefix.'.'.$key] = array(
+		$arrayfields['t.'.$key] = array(
 			'label' => $val['label'],
 			'checked' => (($visible <= 0) ? 0 : 1),
 			'enabled' => (abs($visible) != 3 && (bool) dol_eval($val['enabled'], 1)),
@@ -183,7 +182,7 @@
 	$massaction = '';
 }
 
-$parameters = array('arrayfields' => &$arrayfields);
+$parameters = array();
 $reshook = $hookmanager->executeHooks('doActions', $parameters, $object, $action); // Note that $action and $object may have been modified by some hooks
 if ($reshook < 0) {
 	setEventMessages($hookmanager->error, $hookmanager->errors, 'errors');
@@ -307,8 +306,8 @@
 
 // Build and execute select
 // --------------------------------------------------------------------
-$sql = "SELECT ";
-$sql .= " ".$object->getFieldList('t');
+$sql = 'SELECT ';
+$sql .= $object->getFieldList('t');
 // Add fields from extrafields
 if (!empty($extrafields->attributes[$object->table_element]['label'])) {
 	foreach ($extrafields->attributes[$object->table_element]['label'] as $key => $val) {
@@ -323,13 +322,13 @@
 
 $sqlfields = $sql; // $sql fields to remove for count total
 
-$sql .= " FROM ".$db->prefix().$object->table_element." as t";
+$sql .= " FROM ".MAIN_DB_PREFIX.$object->table_element." as t";
 if (isset($extrafields->attributes[$object->table_element]['label']) && is_array($extrafields->attributes[$object->table_element]['label']) && count($extrafields->attributes[$object->table_element]['label'])) {
 	$sql .= " LEFT JOIN ".MAIN_DB_PREFIX.$object->table_element."_extrafields as ef on (t.rowid = ef.fk_object)";
 }
-$sql .= " LEFT JOIN ".$db->prefix()."mrp_production as lineparent ON t.fk_parent_line = lineparent.rowid";
-$sql .= " LEFT JOIN ".$db->prefix()."mrp_mo as moparent ON lineparent.fk_mo = moparent.rowid";
-$sql .= " LEFT JOIN ".$db->prefix()."product as p ON t.fk_product = p.rowid";
+$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."mrp_production as lineparent ON t.fk_parent_line = lineparent.rowid";
+$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."mrp_mo as moparent ON lineparent.fk_mo = moparent.rowid";
+$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."product as p ON t.fk_product = p.rowid";
 // Add table from hooks
 $parameters = array();
 $reshook = $hookmanager->executeHooks('printFieldListFrom', $parameters, $object, $action); // Note that $action and $object may have been modified by hook
@@ -432,7 +431,7 @@
 		dol_print_error($db);
 	}
 
-	if (($page * $limit) > $nbtotalofrecords) {	// if total resultset is smaller than the paging size (filtering), goto and load page 0
+	if (($page * $limit) > $nbtotalofrecords) {	// if total resultset is smaller than paging size (filtering), goto and load page 0
 		$page = 0;
 		$offset = 0;
 	}
@@ -482,9 +481,6 @@
 if ($optioncss != '') {
 	$param .= '&optioncss='.urlencode($optioncss);
 }
-if ($groupby != '') {
-	$param .= '&groupby='.urlencode($groupby);
-}
 foreach ($search as $key => $val) {
 	if (is_array($search[$key])) {
 		foreach ($search[$key] as $skey) {
@@ -493,9 +489,9 @@
 			}
 		}
 	} elseif (preg_match('/(_dtstart|_dtend)$/', $key) && !empty($val)) {
-		$param .= '&search_'.$key.'month='.GETPOSTINT('search_'.$key.'month');
-		$param .= '&search_'.$key.'day='.GETPOSTINT('search_'.$key.'day');
-		$param .= '&search_'.$key.'year='.GETPOSTINT('search_'.$key.'year');
+		$param .= '&search_'.$key.'month='.((int) GETPOST('search_'.$key.'month', 'int'));
+		$param .= '&search_'.$key.'day='.((int) GETPOST('search_'.$key.'day', 'int'));
+		$param .= '&search_'.$key.'year='.((int) GETPOST('search_'.$key.'year', 'int'));
 	} elseif ($search[$key] != '') {
 		$param .= '&search_'.$key.'='.urlencode($search[$key]);
 	}
@@ -674,7 +670,7 @@
 			}
 			print $form->selectarray('search_'.$key, $val['arrayofkeyval'], (isset($search[$key]) ? $search[$key] : ''), $val['notnull'], 0, 0, '', 1, 0, 0, '', 'maxwidth100', 1);
 		} elseif ((strpos($val['type'], 'integer:') === 0) || (strpos($val['type'], 'sellist:') === 0)) {
-			print $object->showInputField($val, $key, (isset($search[$key]) ? $search[$key] : ''), '', '', 'search_', $cssforfield.' maxwidth125', 1);
+			print $object->showInputField($val, $key, (isset($search[$key]) ? $search[$key] : ''), '', '', 'search_', 'maxwidth125', 1);
 		} elseif (!preg_match('/^(date|timestamp|datetime)/', $val['type'])) {
 			print '<input type="text" class="flat maxwidth'.($val['type'] == 'integer' ? '50' : '75').'" name="search_'.$key.'" value="'.dol_escape_htmltag(isset($search[$key]) ? $search[$key] : '').'">';
 		} elseif (preg_match('/^(date|timestamp|datetime)/', $val['type'])) {
@@ -726,10 +722,9 @@
 		$cssforfield .= ($cssforfield ? ' ' : '').'center';
 	} elseif (in_array($val['type'], array('timestamp'))) {
 		$cssforfield .= ($cssforfield ? ' ' : '').'nowrap';
-	} elseif (in_array($val['type'], array('double(24,8)', 'double(6,3)', 'integer', 'real', 'price')) && !in_array($key, array('id', 'rowid', 'ref', 'status')) && $val['label'] != 'TechnicalID' && empty($val['arrayofkeyval'])) {
+	} elseif (in_array($val['type'], array('double(24,8)', 'double(6,3)', 'integer', 'real', 'price')) && $val['label'] != 'TechnicalID' && empty($val['arrayofkeyval'])) {
 		$cssforfield .= ($cssforfield ? ' ' : '').'right';
 	}
-	$cssforfield = preg_replace('/small\s*/', '', $cssforfield);	// the 'small' css must not be used for the title label
 	if (!empty($arrayfields['t.'.$key]['checked'])) {
 		if ($key == "fk_product") {
 			print getTitleFieldOfList($arrayfields['t.'.$key]['label'], 0, $_SERVER['PHP_SELF'], 'p.ref', '', $param, ($cssforfield ? 'class="'.$cssforfield.'"' : ''), $sortfield, $sortorder, ($cssforfield ? $cssforfield.' ' : ''))."\n";
@@ -742,7 +737,7 @@
 // Extra fields
 include DOL_DOCUMENT_ROOT.'/core/tpl/extrafields_list_search_title.tpl.php';
 // Hook fields
-$parameters = array('arrayfields' => $arrayfields, 'param' => $param, 'sortfield' => $sortfield, 'sortorder' => $sortorder, 'totalarray' => &$totalarray);
+$parameters = array('arrayfields' => $arrayfields, 'param' => $param, 'sortfield' => $sortfield, 'sortorder' => $sortorder);
 $reshook = $hookmanager->executeHooks('printFieldListTitle', $parameters, $object, $action); // Note that $action and $object may have been modified by hook
 print $hookmanager->resPrint;
 // Action column
@@ -784,7 +779,7 @@
 	$object->setVarsFromFetchObj($obj);
 
 
-	if ($mode == 'kanban' || $mode == 'kanbangroupby') {
+	if ($mode == 'kanban') {
 		if ($i == 0) {
 			print '<tr class="trkanban"><td colspan="'.$savnbfield.'">';
 			print '<div class="box-flex-container kanban">';
@@ -856,7 +851,7 @@
 			if (!empty($arrayfields['t.'.$key]['checked'])) {
 				print '<td'.($cssforfield ? ' class="'.$cssforfield.((preg_match('/tdoverflow/', $cssforfield) && !in_array($val['type'], array('ip', 'url')) && !is_numeric($object->$key)) ? ' classfortooltip' : '').'"' : '');
 				if (preg_match('/tdoverflow/', $cssforfield) && !in_array($val['type'], array('ip', 'url')) && !is_numeric($object->$key)) {
-					print ' title="'.dolPrintHTMLForAttribute((string) $object->$key).'"';
+					print ' title="'.dol_escape_htmltag((string) $object->$key).'"';
 				}
 				print '>';
 				if ($key == 'status') {
@@ -869,14 +864,7 @@
 				} elseif ($key == 'rowid') {
 					print $object->showOutputField($val, $key, (string) $object->id, '');
 				} else {
-					if ($val['type'] == 'html') {
-						print '<div class="small lineheightsmall twolinesmax-normallineheight">';
-					}
 					print $object->showOutputField($val, $key, (string) $object->$key, '');
-					if ($val['type'] == 'html') {
-						print '</div>';
-					}
-
 					if ($key == 'date_end_planned' && $object->hasDelay()) {
 						print img_warning($langs->trans('Alert').' - '.$langs->trans('Late'));
 					}
@@ -946,7 +934,7 @@
 $db->free($resql);
 
 $parameters = array('arrayfields' => $arrayfields, 'sql' => $sql);
-$reshook = $hookmanager->executeHooks('printFieldListFooter', $parameters, $object, $action); // Note that $action and $object may have been modified by hook
+$reshook = $hookmanager->executeHooks('printFieldListFooter', $parameters, $object); // Note that $action and $object may have been modified by hook
 print $hookmanager->resPrint;
 
 print '</table>'."\n";

########## mrp/mo_movements.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/mrp/mo_movements.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/mrp/mo_movements.php	2025-06-27 11:43:57.695015000 +0000
@@ -97,7 +97,7 @@
 $object = new Mo($db);
 $extrafields = new ExtraFields($db);
 $diroutputmassaction = $conf->mrp->dir_output.'/temp/massgeneration/'.$user->id;
-$hookmanager->initHooks(array('mocard', 'globalcard', 'mocardmovelist' )); // Note that conf->hooks_modules contains array
+$hookmanager->initHooks(array('mocard', 'globalcard')); // Note that conf->hooks_modules contains array
 
 // Fetch optionals attributes and labels
 $extrafields->fetch_name_optionals_label($object->table_element);
@@ -966,7 +966,7 @@
 		// Inventory code
 		if (!empty($arrayfields['m.inventorycode']['checked'])) {
 			print '<td class="tdoverflowmax150" title="'.dol_escape_htmltag($objp->inventorycode).'">';
-			//print '<a href="' . DOL_URL_ROOT . '/product/stock/movement_list.php' . '?id=' . ((int) $objp->entrepot_id) . '&search_inventorycode=' . urlencode($objp->inventorycode) . '&search_type_mouvement=' . urlencode($objp->type_mouvement) . '">';
+			//print '<a href="' . DOL_URL_ROOT . '/product/stock/movement_card.php' . '?id=' . $objp->entrepot_id . '&amp;search_inventorycode=' . $objp->inventorycode . '&amp;search_type_mouvement=' . $objp->type_mouvement . '">';
 			print dol_escape_htmltag($objp->inventorycode);
 			//print '</a>';
 			print '</td>';

########## partnership/class/api_partnerships.class.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/partnership/class/api_partnerships.class.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/partnership/class/api_partnerships.class.php	2025-06-27 11:43:57.521976000 +0000
@@ -113,7 +113,7 @@
 			throw new RestException(403);
 		}
 
-		$socid = DolibarrApiAccess::$user->socid ?: 0;
+		$socid = DolibarrApiAccess::$user->socid ? DolibarrApiAccess::$user->socid : 0;
 
 		$restrictonsocid = 0; // Set to 1 if there is a field socid in table of object
 

########## partnership/core/modules/partnership/mod_partnership_standard.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/partnership/core/modules/partnership/mod_partnership_standard.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/partnership/core/modules/partnership/mod_partnership_standard.php	2025-06-27 11:43:57.531293000 +0000
@@ -97,7 +97,7 @@
 		$sql .= " WHERE ref LIKE '".$db->escape($this->prefix)."____-%'";
 		if ($object->ismultientitymanaged == 1) {
 			$sql .= " AND entity = ".$conf->entity;
-		} elseif (!is_numeric($object->ismultientitymanaged)) {
+		} elseif ($object->ismultientitymanaged == 2) {
 			// TODO
 		}
 
@@ -135,7 +135,7 @@
 		$sql .= " WHERE ref LIKE '".$db->escape($this->prefix)."____-%'";
 		if ($object->ismultientitymanaged == 1) {
 			$sql .= " AND entity = ".$conf->entity;
-		} elseif (!is_numeric($object->ismultientitymanaged)) {
+		} elseif ($object->ismultientitymanaged == 2) {
 			// TODO
 		}
 

########## paypal/lib/paypal.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/paypal/lib/paypal.lib.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/paypal/lib/paypal.lib.php	2025-06-27 11:43:59.592903000 +0000
@@ -459,7 +459,7 @@
 
 	// TODO problem with triggers
 	$API_version = "98.0";
-	if (getDolGlobalString('PAYPAL_API_SANDBOX')/* || GETPOST('forcesandbox', 'alpha') */) {		// We can force sand box with param 'forcesandbox'
+	if (getDolGlobalString('PAYPAL_API_SANDBOX') || GETPOST('forcesandbox', 'alpha')) {		// We can force sand box with param 'forcesandbox'
 		$API_Endpoint = "https://api-3t.sandbox.paypal.com/nvp";
 		$API_Url = "https://www.sandbox.paypal.com/webscr?cmd=_express-checkout&token=";
 	} else {

########## paypal/lib/paypalfunctions.lib.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/paypal/lib/paypalfunctions.lib.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/paypal/lib/paypalfunctions.lib.php	2025-06-27 11:43:59.593938000 +0000
@@ -49,7 +49,7 @@
  ' For the sandbox, the URL is       https://www.sandbox.paypal.com/webscr&cmd=_express-checkout&token=
  ' For the live site, the URL is        https://www.paypal.com/webscr&cmd=_express-checkout&token=
  */
-if (getDolGlobalString('PAYPAL_API_SANDBOX')/* || GETPOST('forcesandbox', 'alpha') */) {		// We can force sand box with param 'forcesandbox'
+if (getDolGlobalString('PAYPAL_API_SANDBOX') || GETPOST('forcesandbox', 'alpha')) {		// We can force sand box with param 'forcesandbox'
 	$API_Endpoint = "https://api-3t.sandbox.paypal.com/nvp";
 	$API_Url = "https://www.sandbox.paypal.com/webscr?cmd=_express-checkout&token=";
 } else {

########## product/ajax/products.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/product/ajax/products.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/product/ajax/products.php	2025-06-27 11:43:59.716228000 +0000
@@ -184,7 +184,7 @@
 			$sql .= " WHERE fk_product = ".((int) $id);
 			$sql .= " AND entity IN (".getEntity('productprice').")";
 			$sql .= " AND price_level = ".((int) $price_level);
-			$sql .= " ORDER BY date_price DESC, rowid";
+			$sql .= " ORDER BY date_price";
 			$sql .= " DESC LIMIT 1";
 
 			$result = $db->query($sql);

########## product/card.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/product/card.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/product/card.php	2025-06-27 11:43:59.629832000 +0000
@@ -1363,18 +1363,6 @@
 $sellOrEatByMandatoryList = null;
 if (isModEnabled('productbatch')) {
 	$sellOrEatByMandatoryList = Product::getSellOrEatByMandatoryList();
-
-	$disableSellBy = getDolGlobalString('PRODUCT_DISABLE_SELLBY');
-	$disableEatBy  = getDolGlobalString('PRODUCT_DISABLE_EATBY');
-
-	if ($disableSellBy) {
-		unset($sellOrEatByMandatoryList[Product::SELL_OR_EAT_BY_MANDATORY_ID_SELL_BY]);
-		unset($sellOrEatByMandatoryList[Product::SELL_OR_EAT_BY_MANDATORY_ID_SELL_AND_EAT]);
-	}
-	if ($disableEatBy) {
-		unset($sellOrEatByMandatoryList[Product::SELL_OR_EAT_BY_MANDATORY_ID_EAT_BY]);
-		unset($sellOrEatByMandatoryList[Product::SELL_OR_EAT_BY_MANDATORY_ID_SELL_AND_EAT]);
-	}
 }
 
 $title = $langs->trans('ProductServiceCard');

########## product/class/api_products.class.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/product/class/api_products.class.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/product/class/api_products.class.php	2025-06-27 11:43:59.748232000 +0000
@@ -3,7 +3,6 @@
  * Copyright (C) 2019		Cedric Ancelin			<icedo.anc@gmail.com>
  * Copyright (C) 2024		Frédéric France			<frederic.france@free.fr>
  * Copyright (C) 2024-2025	MDW						<mdeweerd@users.noreply.github.com>
- * Copyright (C) 2025		William Mead			<william@m34d.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -197,13 +196,15 @@
 	 */
 	public function index($sortfield = "t.ref", $sortorder = 'ASC', $limit = 100, $page = 0, $mode = 0, $category = 0, $sqlfilters = '', $ids_only = false, $variant_filter = 0, $pagination_data = false, $includestockdata = 0, $properties = '')
 	{
+		global $db, $conf;
+
 		if (!DolibarrApiAccess::$user->hasRight('produit', 'lire')) {
 			throw new RestException(403);
 		}
 
 		$obj_ret = array();
 
-		$socid = DolibarrApiAccess::$user->socid ?: '';
+		$socid = DolibarrApiAccess::$user->socid ? DolibarrApiAccess::$user->socid : '';
 
 		$sql = "SELECT t.rowid, t.ref, t.ref_ext";
 		$sql .= " FROM ".$this->db->prefix()."product as t";
@@ -450,10 +451,8 @@
 				if ($this->product->tva_npr != $oldproduct->tva_npr) {
 					$pricemodified = true;
 				}
-				if (!empty($this->product->default_vat_code)) {
-					if ($this->product->default_vat_code != $oldproduct->default_vat_code) {
-						$pricemodified = true;
-					}
+				if ($this->product->default_vat_code != $oldproduct->default_vat_code) {
+					$pricemodified = true;
 				}
 
 				if ($this->product->price_base_type == 'TTC') {
@@ -799,7 +798,7 @@
 			throw new RestException(400, 'API not available: this mode of pricing is not enabled by setup');
 		}
 
-		$socid = DolibarrApiAccess::$user->socid ?: '';
+		$socid = DolibarrApiAccess::$user->socid ? DolibarrApiAccess::$user->socid : '';
 		if ($socid > 0 && $socid != $thirdparty_id) {
 			throw new RestException(403, 'Getting prices for all customers or for the customer ID '.$thirdparty_id.' is not allowed for login '.DolibarrApiAccess::$user->login);
 		}
@@ -919,7 +918,7 @@
 			throw new RestException(403, 'Access not allowed for login '.DolibarrApiAccess::$user->login);
 		}
 
-		$socid = DolibarrApiAccess::$user->socid ?: '';
+		$socid = DolibarrApiAccess::$user->socid ? DolibarrApiAccess::$user->socid : '';
 		if ($socid > 0 && $socid != $fourn_id) {
 			throw new RestException(403, 'Adding purchase price for the supplier ID '.$fourn_id.' is not allowed for login '.DolibarrApiAccess::$user->login);
 		}
@@ -1017,7 +1016,7 @@
 		$obj_ret = array();
 
 		// Force id of company for external users
-		$socid = DolibarrApiAccess::$user->socid ?: '';
+		$socid = DolibarrApiAccess::$user->socid ? DolibarrApiAccess::$user->socid : '';
 		if ($socid > 0) {
 			if ($supplier != $socid || empty($supplier)) {
 				throw new RestException(403, 'As an external user, you can request only for your supplier id = '.$socid);
@@ -1130,7 +1129,7 @@
 			throw new RestException(403);
 		}
 
-		$socid = DolibarrApiAccess::$user->socid ?: '';
+		$socid = DolibarrApiAccess::$user->socid ? DolibarrApiAccess::$user->socid : '';
 
 		$result = $this->product->fetch($id, $ref, $ref_ext, $barcode);
 		if (!$result) {

########## product/class/product.class.php
--- /homez.786/ridinteadu/_serious_analysis/van_22.0.0/dolibarr-22.0.0/htdocs/product/class/product.class.php	2025-08-04 13:08:35.000000000 +0000
+++ /homez.786/ridinteadu/seriousalpha/dolibarr/htdocs/product/class/product.class.php	2025-06-27 11:43:59.745911000 +0000
@@ -363,14 +363,12 @@
 	/**
 	 * Cost price
 	 *
-	 * @var ?float
+	 * @var float
 	 */
 	public $cost_price;
 
 	/**
-	 * Average price value for product entry into stock (PMP)
-	 *
-	 * @var ?float
+	 * @var float Average price value for product entry in stock (PMP)
 	 */
 	public $pmp;
 
@@ -783,7 +781,7 @@
 	 *
 	 * @var array<string,array<int,array{0:int,1:float,2:int,3:string,4:int,5:string}>>
 	 */
-	public $sousprods = array();
+	public $sousprods;
 
 	/**
 	 * @var array<int,array{id:int,id_parent:int,ref:string,nb:int,nb_total:int,stock:float,stock_alert:float,label:string,fullpath:string,type:int,desiredstick:float,level:int,incdec:int<0,1>,entity:CommonObject}> Path of subproducts. Build from ->sousprods with get_arbo_each_prod()
@@ -1958,9 +1956,9 @@
 	}
 
 	/**
-	 * Get the array of labels of Sell by or Eat by all mandatory flags for each status
+	 * Get sell or eat by mandatory list
 	 *
-	 * @return 	array{0:string,1:string,2:string,3:string}	Array of labels of Sell by or Eat by all mandatory flags
+	 * @return 	array{0:string,1:string,2:string,3:string}	Sell or eat by mandatory list
 	 */
 	public static function getSellOrEatByMandatoryList()
 	{
@@ -1977,9 +1975,9 @@
 	}
 
 	/**
-	 * Get the label for sell by or eat by mandatory flag of the current product
+	 * Get sell or eat by mandatory label
 	 *
-	 * @return 	string		Sell or eat by mandatory label
+	 * @return 	string	Sell or eat by mandatory label
 	 */
 	public function getSellOrEatByMandatoryLabel()
 	{
@@ -1996,8 +1994,8 @@
 	/**
 	 *    Update or add a translation for a product
 	 *
-	 * @param  User $user 	Object user making update
-	 * @return int        	Return integer <0 if KO, >0 if OK
+	 * @param  User $user Object user making update
+	 * @return int        Return integer <0 if KO, >0 if OK
 	 */
 	public function setMultiLangs($user)
 	{
@@ -3058,7 +3056,7 @@
 				$this->price_min = $obj->price_min;
 				$this->price_min_ttc = $obj->price_min_ttc;
 				$this->price_base_type = $obj->price_base_type;
-				$this->cost_price = isset($obj->cost_price) ? (float) $obj->cost_price : null;
+				$this->cost_price = $obj->cost_price;
 				$this->default_vat_code = $obj->default_vat_code;
 				$this->tva_tx = $obj->tva_tx;
 				//! French VAT NPR
@@ -6111,7 +6109,7 @@
 	 * @param	float			$nbpiece		nb of units (should be always positive, use $movement to decide if we add or remove)
 	 * @param	int<0,1>		$movement		0 = add, 1 = remove
 	 * @param	string			$label			Label of stock movement
-	 * @param	int|float		$price			Unit price HT of product, used to calculate average weighted price (PMP in french). If 0, average weighted price is not changed.
+	 * @param	float			$price			Unit price HT of product, used to calculate average weighted price (PMP in french). If 0, average weighted price is not changed.
 	 * @param	string			$inventorycode	Inventory code
 	 * @param	string			$origin_element	Origin element type
 	 * @param	?int			$origin_id		Origin id of element
@@ -6167,22 +6165,22 @@
 	/**
 	 *  Adjust stock in a warehouse for product with batch number
 	 *
-	 * @param	User			$user           	User asking change
-	 * @param	int				$id_entrepot    	Id of warehouse
-	 * @param	float			$nbpiece        	Nb of units (should be always positive, use $movement to decide if we add or remove)
-	 * @param	int<0,1>		$movement       	0 = add, 1 = remove
-	 * @param	string			$label          	Label of stock movement
-	 * @param	int|float		$price          	Price to use for stock eval
-	 * @param	int|string		$dlc            	eat-by date
-	 * @param	int|string		$dluo           	sell-by date
-	 * @param	string			$lot            	Lot number
-	 * @param	string			$inventorycode  	Inventory code
-	 * @param	string			$origin_element 	Origin element type
-	 * @param	?int			$origin_id      	Origin id of element
-	 * @param	int				$disablestockchangeforsubproduct	Disable stock change for sub-products of kit (useful only if product is a subproduct)
-	 * @param	?ExtraFields	$extrafields		Array of extrafields
-	 * @param	boolean			$force_update_batch Force update batch
-	 * @return int              		        	Return integer <0 if KO, >0 if OK
+	 * @param	User		$user           user asking change
+	 * @param	int			$id_entrepot    id of warehouse
+	 * @param	float		$nbpiece        nb of units (should be always positive, use $movement to decide if we add or remove)
+	 * @param	int<0,1>	$movement       0 = add, 1 = remove
+	 * @param	string		$label          Label of stock movement
+	 * @param	float		$price          Price to use for stock eval
+	 * @param	int|string	$dlc            eat-by date
+	 * @param	int|string	$dluo           sell-by date
+	 * @param	string		$lot            Lot number
+	 * @param	string		$inventorycode  Inventory code
+	 * @param	string		$origin_element Origin element type
+	 * @param	?int		$origin_id      Origin id of element
+	 * @param	int			$disablestockchangeforsubproduct	Disable stock change for sub-products of kit (useful only if product is a subproduct)
+	 * @param	?ExtraFields	$extrafields	Array of extrafields
+	 * @param	boolean		$force_update_batch   Force update batch
+	 * @return int                      Return integer <0 if KO, >0 if OK
 	 */
 	public function correct_stock_batch($user, $id_entrepot, $nbpiece, $movement, $label = '', $price = 0, $dlc = '', $dluo = '', $lot = '', $inventorycode = '', $origin_element = '', $origin_id = null, $disablestockchangeforsubproduct = 0, $extrafields = null, $force_update_batch = false)
 	{

########## product/inventory/inventory.php
